/*******************************************************************************
*                                                                              *
*                                   Viewmol                                    *
*                                                                              *
*                             M A K E T I C S . C                              *
*                                                                              *
*                 Copyright (c) Joerg-R. Hill, December 1996                   *
*                                                                              *
********************************************************************************
*
* $Id: maketics.c,v 1.1 1996/12/10 18:41:45 jrh Exp $
* $Log: maketics.c,v $
 * Revision 1.1  1996/12/10  18:41:45  jrh
 * Initial revision
 *
*
*/
#include<math.h>
#include<stdio.h>

double dbl_raise(double x, int y)
{
  register int i;
  double val;

  val=1.0e0;
  for (i=0; i<abs(y); i++)
    val*=x;
  if (y < 0 ) return(1.0e0/val);
  return(val);
}


double makeTics(double tmin, double tmax, double *start, char *format)
{
  register double r, logr, tic;

  r=fabs(tmin-tmax);
  logr=log10(r);
  r=pow(10.0e0, logr-(double)((logr >= 0.0 ) ? (int)logr : ((int)logr-1)));
  if (r <= 2.0e0)
    tic=0.2e0;
  else if (r <= 5.0e0)
    tic=0.5e0;
  else
    tic=1.0e0;
  if (logr > 0.0e0)
    sprintf(format, "%%%dg", (int)logr+2);
  else
    sprintf(format, "%%.%dg", (int)(-logr)+(tmin == 0.0e0 ? 0 : (int)log10(fabs(tmin))+2));

  tic*=dbl_raise(10.0e0, (logr >= 0.0 ) ? (int)logr : ((int)logr-1));
  *start=tic*ceil(tmin/tic);
  return(tic);
}
